package ast;

import types.Type;

public class Div extends Node implements Exp {
	public Exp l;
	public Exp r;
	
	public Div(Exp l, Exp r, int line, int col) {
		super(line, col);
		this.l = l;
		this.r = r;
	}
	
	public Object eval(Environment<Object> env) {
		return (Double)l.eval(env) / (Double)r.eval(env);
	}
	
	public String label() {
		return "/";
	}

	@Override
	public Type tcExp(Environment<Type> tenv) {
		Type tl = l.tcExp(tenv);
		tl.unify(types.Num.type, (Node)l);
		Type tr = r.tcExp(tenv);
		tr.unify(types.Num.type, (Node)r);
		return types.Num.type;
	}
}
