package ast;

import types.Type;

public class Menor extends Node implements Exp {
	public Exp l;
	public Exp r;
	
	public Menor(Exp l, Exp r, int line, int col) {
		super(line, col);
		this.l = l;
		this.r = r;
	}

	@Override
	public Object eval(Environment<Object> env) {
		Comparable<Object> c = (Comparable<Object>)l.eval(env);
		return c.compareTo(r.eval(env)) < 0;
	}

	@Override
	public Type tcExp(Environment<Type> tenv) {
		Type tl = l.tcExp(tenv);
		Type tr = r.tcExp(tenv);
		tl.constraint("ord", (Node)l);
		tr.constraint("ord", (Node)r);
		tl.unify(tr, this);
		return types.Bool.type;
	}

	@Override
	public String label() {
		return "<";
	}

}
